"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaymentMethodDetailsNotification = void 0;
const payment_card_notification_js_1 = require("./payment-card-notification.js");
const payment_method_underlying_details_notification_js_1 = require("./payment-method-underlying-details-notification.js");
class PaymentMethodDetailsNotification {
    type;
    card;
    underlyingDetails;
    constructor(paymentMethodDetails) {
        this.type = paymentMethodDetails.type;
        this.card = paymentMethodDetails.card ? new payment_card_notification_js_1.PaymentCardNotification(paymentMethodDetails.card) : null;
        this.underlyingDetails = paymentMethodDetails.underlying_details
            ? new payment_method_underlying_details_notification_js_1.PaymentMethodUnderlyingDetailsNotification(paymentMethodDetails.underlying_details)
            : null;
    }
}
exports.PaymentMethodDetailsNotification = PaymentMethodDetailsNotification;
