import { DiscountGroup, DiscountGroupCollection } from '../../entities/index.js';
import { BaseResource, QueryParameters } from '../../internal/base/index.js';
const DiscountGroupPaths = {
    list: '/discount-groups',
    create: '/discount-groups',
};
export * from './operations/index.js';
export class DiscountGroupsResource extends BaseResource {
    list(queryParams) {
        const queryParameters = new QueryParameters(queryParams);
        return new DiscountGroupCollection(this.client, DiscountGroupPaths.list + queryParameters.toQueryString());
    }
    async create(createDiscountGroupRequestBody) {
        const response = await this.client.post(DiscountGroupPaths.create, createDiscountGroupRequestBody);
        const data = this.handleResponse(response);
        return new DiscountGroup(data);
    }
}
